/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code demonstrates the modification of resources belonging
to the toplevel shell.
***************************************************************/

/* shell.c */

#include <Xm/Xm.h>

#include "folder.xbm"

XtAppContext context;

Widget toplevel;

void main(argc,argv)
    int argc;
    char *argv[];
{
    Arg al[20];
    int ac;
    int foreground,background;
    Pixmap pix;
    unsigned int depth;

    /* create the toplevel shell */
    toplevel = XtAppInitialize(&context,"",NULL,0,&argc,argv,
        NULL,NULL,0);

    /* create the bitmap for the icon pixmap. */
    pix=XCreateBitmapFromData(XtDisplay(toplevel),
        RootWindowOfScreen(XtScreen(toplevel)),
        folder_bits,folder_width,folder_height);

    /* modify toplevel. */
    ac=0;
    XtSetArg(al[ac], XmNtitle, "Sample Title"); ac++;
    XtSetArg(al[ac], XmNminWidth, 200); ac++;
    XtSetArg(al[ac], XmNmaxWidth, 400); ac++;
    XtSetArg(al[ac], XmNminHeight, 200); ac++;
    XtSetArg(al[ac], XmNmaxHeight, 400); ac++;
    XtSetArg(al[ac], XmNiconPixmap, pix); ac++;
    XtSetArg(al[ac], XmNheight, 300); ac++;
    XtSetArg(al[ac], XmNwidth, 300); ac++;
    XtSetValues(toplevel,al,ac);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(context);
}
