/***************************************************************
From the book "Motif Programming, The Essentials...and More"
by Marshall Brain.
Published by Digital Press, ISBN 1-55558-089-0.
To order the book, call 1-800-DIGITAL and ask for EY-J816E-DP.

Copyright 1992, by Digital Equipment Corp.

This code demonstrates a prompt dialog.
***************************************************************/

/* prompt.c*/

#include <Xm/Xm.h>
#include <Xm/PushB.h>
#include <Xm/SelectioB.h>
/* a prompt dialog is made from a stripped-down selection box. */

#define    OK        1
#define    CANCEL    2

XtAppContext context;
XmStringCharSet char_set = XmSTRING_DEFAULT_CHARSET;

Widget toplevel, button, dialog;

void dialogCB(w,client_data,call_data)
    Widget w;
    int client_data;
    XmSelectionBoxCallbackStruct *call_data;
/* callback function for the dialog box */
{
    char *s;

    switch (client_data)
    {         
        case OK:
            /* get the string from the event structure. */
            XmStringGetLtoR(call_data->value,char_set,&s);
            printf("string='%s'\n",s);
            XtFree(s);
            break;         
        case CANCEL:
            printf("CANCEL selected\n");
            break;
    }
    /* make the dialog box invisible */
    XtUnmanageChild(w);
}

void buttonCB(w,client_data,call_data)
    Widget w;
    XtPointer client_data;
    XmPushButtonCallbackStruct *call_data;
/* callback function for the dialog box */
{
    /* make the dialog box visible */
    XtManageChild(dialog);
}

void main(argc,argv)
    int argc; 
    char *argv[];
{
    Arg al[10];
    int ac;

    /* create the toplevel shell */
    toplevel = XtAppInitialize(&context,"",NULL,0,&argc,argv,NULL,NULL,0);

    /* create the dialog box. */
    ac=0;
    XtSetArg(al[ac], XmNselectionLabelString, 
        XmStringCreateLtoR("Type in a string. ",char_set)); ac++;
    dialog = XmCreatePromptDialog(toplevel,"dialog",al,ac);
    XtAddCallback(dialog,XmNokCallback,dialogCB,OK);
    XtAddCallback(dialog,XmNcancelCallback,dialogCB,CANCEL);
    XtUnmanageChild(XmSelectionBoxGetChild(dialog,
        XmDIALOG_HELP_BUTTON));

    /* create the pushbutton */
    ac=0;       
    XtSetArg(al[ac],XmNlabelString,
        XmStringCreate("Push Me",char_set)); ac++;
    button=XmCreatePushButton(toplevel,"label",al,ac);
    XtManageChild(button);
    XtAddCallback (button, XmNactivateCallback, buttonCB, NULL);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(context);
}
